/**
 * Translator Revolution WP Plugin
 * http://goo.gl/4E7Mx
 *
 * LICENSE
 *
 * You need to buy a license if you want use this script.
 * http://codecanyon.net/legal/market
 *
 * @package    Translator Revolution WP Plugin
 * @copyright  Copyright (c) 2015, SurStudio, www.surstudio.net
 * @license    http://codecanyon.net/licenses/standard
 * @version    1.8
 * @date       2015-02-02
 */

var SurStudioPluginTranslatorRevolutionLiteCommon = {

	$: function() {
		var _elements = new Array();
		for (var i = 0; i < arguments.length; i++) {
			var _element = arguments[i];
			if (typeof _element == "string")
				_element = document.getElementById(_element);
			if (arguments.length == 1)
				return _element;
			_elements.push(_element);
		}
		return _elements;
	},
	
	addEvent: function(element, evType, fn, useCapture) {
		if(element.addEventListener) {
			element.addEventListener(evType, fn, useCapture);
			return true;
		}
		else if(element.attachEvent) {
			var r = element.attachEvent("on" + evType, fn);
			return r;
		}
		else {
			element["on" + evType] = fn;
		}
	},

	mergeText: function(message, newValuesArray) {
		result = message;
		var i = 0;
		for(var i=0; i<newValuesArray.length; i++) result = result.replace("["+i+"]", newValuesArray[i]);
		return result;
	},

	unserialize: function(_url) {

		var result = {};
		var full_option;
		var option;
		var value;
		var params = _url;
		var single = arguments[1] || false;

		params = params.slice(params.indexOf('?') + 1).split("&");

		for (var i=0; i<params.length; i++) {
			
			full_option = params[i].split("=");
			option = full_option[0];
			value = full_option[1];

			if (single == option)
				return value;
			
			result[option] = value;
				
		}

		if (single !== false)
			return false;

		return result;
	
	},

	cleanId: function(_string, _separator) {
		
		var separator = _separator || "-";
		
		return _string.replace(/[^a-zA-Z0-9]+|\s+/g, separator).toLowerCase();
		
	},

	getOwnerParent: function(_element) {
		
		if (_element._owner)
			return _element;

		var result = _element.parentNode;
		try {
			while (!result._owner) 
				result = result.parentNode;
			return result;
		}
		catch(e) {
			return null;
		}

	},

	getFieldValue: function(_container) {
		
		var fields = jQuery(_container).find("input[type=radio]");
		
		if (fields.length > 0) {
			for (var i=0; i<fields.length; i++)
				if (fields[i].checked)
					return fields[i].value;
		}
		else {
			
			fields = jQuery(_container).find("select");
		
			if (fields.length > 0)
				return fields[0].value;

		}

		return false;
		
	},
	
	getOwner: function(e) {

		return e.srcElement || e.target;

	},
	
	trim: function(_string) {
		
		return this != window ? _string.replace(/^\s*|\s*$/g,"") : null;

	},
	
	setUploadImageTarget: function(_callback, _target_id) {

		window.send_to_editor = function(_html) {

			var img = jQuery(_html);
			if (img[0].nodeName.toLowerCase() != "img")
				img = img.find("img");
			
			var uri = img.attr("src");
			var id = img.attr("class").match(/\bwp-image-(.*)(\d+)\b/gi);
			if (id)
				id = id[0].replace("wp-image-", "");
			
			_callback(uri, id, _target_id);
			tb_remove();
		}

	},
	
	getX: function(element) { 
		x=0;
		if (!document.layers) {
			var onWindows = navigator.platform ? navigator.platform == "Win32" : false;
			var macIE45 = document.all && !onWindows && getExplorerVersion() == 4.5;
			var par = element;
			var lastOffset = 0;
			while(par){
				if( par.leftMargin && ! onWindows ) x += parseInt(par.leftMargin);
				if( (par.offsetLeft != lastOffset) && par.offsetLeft ) x += parseInt(par.offsetLeft);
				if( par.offsetLeft != 0 ) lastOffset = par.offsetLeft;
				par = macIE45 ? par.parentElement : par.offsetParent;
			}
		} else if (element.x) x += element.x;
		return x;
	},

	getY: function(element) {
		y=0;
		if(!document.layers) {
			var onWindows = navigator.platform ? navigator.platform == "Win32" : false;
			var macIE45 = document.all && !onWindows && getExplorerVersion() == 4.5;
			var par = element;
			var lastOffset = 0;
			while(par){
				if( par.topMargin && !onWindows ) y += parseInt(par.topMargin);
				if( (par.offsetTop != lastOffset) && par.offsetTop ) y += parseInt(par.offsetTop);
				if( par.offsetTop != 0 ) lastOffset = par.offsetTop;
				par = macIE45 ? par.parentElement : par.offsetParent;
			}		
		} else if (element.y >= 0) y += element.y;
		return y;
	},
	
	setX: function(element, posX) {
		element.style.left = posX + "px";
	},

	setY: function(element, posY) {
		element.style.top = posY + "px";
	},

	startsWith: function(_string, substr) {
		if (this == window) return null;
		return _string.substring(0, substr.length) == substr;
	},

	endsWith: function(_string, substr) {
		if (this == window) return null;
		return _string.length >= substr.length && _string.substring(_string.length - substr.length) == substr;
	},
	
	inArray: function(_value, _array, _property) {
	
		if (!(_array instanceof Array))
			_array = _array.split(",");

		for (var i=0; i<_array.length; i++) {
			if (_array[i] instanceof Object) {
				if (_array[i][_property] == _value)
					return i;
			}				
			else if (_array[i] == _value)
				return i;
		}
				
		return false;
		
	},
	
	getHeadingContainer: function(_item) {

		var section = jQuery(_item).parents(".surstudio_plugin_translator_revolution_lite_section");
		var heading = section.prevUntil(".surstudio_plugin_translator_revolution_lite_heading");
		var result = heading.length > 0 ? jQuery(heading[heading.length-1]) : section;
			
		return result.prev();
		
	},
	
	getHeadingObject: function(_item, _headings) {

		var heading_container = this.getHeadingContainer(_item);
		var heading_id = heading_container.attr("id");
		return _headings[heading_id];
		
	}
	
};

SurStudioPluginTranslatorRevolutionLiteCommon.Dependencies = {
	
	_targets: {},

	_record: function(_target) {
		
		var foo = _target[0];
		var section = jQuery(foo).parents(".surstudio_plugin_translator_revolution_lite_section");
		
		this._targets[section.attr("id")] = _target;
		
	},	
	
	simulate: function(_section) {
		
		var section_id = _section.id;
		var type;

		if (typeof this._targets[section_id] != "object")
			return false;
		
		if (SurStudioPluginTranslatorRevolutionLiteCommon.CSS.hasClass(_section, "surstudio_plugin_translator_revolution_lite_toggle"))
			type = "toggle";

		switch (type) {
			case "toggle": {
				for (var i=0; i<this._targets[section_id].length; i++)
					if (this._targets[section_id][i].checked)
						jQuery(this._targets[section_id][i]).click();
				break;
			}
		}
		
	},
	
	add: function(_target, _event, _function) {
		
		this._record(_target);
		
		_target.bind("click", _function);
		
	}
	
};

SurStudioPluginTranslatorRevolutionLiteCommon.Heading = function(_target) {
	
	this._id = _target.id;
	this._target = _target;
	this._items = [];

	this._initialize_items();
	this._initialize_events();
	this._set_styles();	
	
};
	
SurStudioPluginTranslatorRevolutionLiteCommon.Heading.prototype._initialize_events = function() {
	
	SurStudioPluginTranslatorRevolutionLiteCommon.addEvent(this._target, "click", function(e) {

		var owner = SurStudioPluginTranslatorRevolutionLiteCommon.getOwnerParent(SurStudioPluginTranslatorRevolutionLiteCommon.getOwner(e));
		owner._owner._click();
		
	}, false);
	
};

SurStudioPluginTranslatorRevolutionLiteCommon.Heading.prototype.isShowing = function() {
	
	return !SurStudioPluginTranslatorRevolutionLiteCommon.CSS.hasClass(this._target, "surstudio_plugin_translator_revolution_lite_heading_hiding");
	
};

SurStudioPluginTranslatorRevolutionLiteCommon.Heading.prototype._click = function() {
	
	this._show(!this.isShowing());
	
};

SurStudioPluginTranslatorRevolutionLiteCommon.Heading.prototype._show = function(_state, _now) {

	SurStudioPluginTranslatorRevolutionLiteCommon.CSS.chooseClass(this._target, _state, "surstudio_plugin_translator_revolution_lite_heading_showing", "surstudio_plugin_translator_revolution_lite_heading_hiding");

	var items = jQuery(this._items);
	items = items.not(".surstudio_plugin_translator_revolution_lite_no_display.surstudio_plugin_translator_revolution_lite_section_tabbed_2");

	if (_now === true) {
		if (_state)
			items.show();
		else
			items.hide();
	}
	else {
		if (_state)
			items.slideDown("fast");
		else
			items.slideUp("fast");

		SurStudioPluginTranslatorRevolutionLiteCommon.Cookie.set("surstudio_plugin_translator_revolution_lite_heading_" + this._id, _state ? "true" : "false", 10, false, false, false);

	}
	
	this._click_items(items, _now === true); // to satisfy dependencies

};

SurStudioPluginTranslatorRevolutionLiteCommon.Heading.prototype._click_items = function(_items, _delayed) {

	if (_delayed)
		setTimeout(function() {
			for (var i=0; i<_items.length; i++)
				SurStudioPluginTranslatorRevolutionLiteCommon.Dependencies.simulate(_items[i]);
		}, 200);
	else
		for (var i=0; i<_items.length; i++)
			SurStudioPluginTranslatorRevolutionLiteCommon.Dependencies.simulate(_items[i]);
	
};

SurStudioPluginTranslatorRevolutionLiteCommon.Heading.prototype._click_item = function(_item, _name) {
	
	var type;
	
	if (SurStudioPluginTranslatorRevolutionLiteCommon.CSS.hasClass(_item, "surstudio_plugin_translator_revolution_lite_toggle"))
		type = "toggle";
	
	switch (type) {
		case "toggle": {
			
			break;
		}
	}
	
};

SurStudioPluginTranslatorRevolutionLiteCommon.Heading.prototype._initialize_items = function() {

	this._target._owner = this;
	
	var item = this._get_next_sibling(this._target);

	while (item != null && item.className.match(/\bsurstudio_plugin_translator_revolution_lite_section_tabbed_\d+\b/)) {
		this._items.push(item);
		item = this._get_next_sibling(item);
	}
	
	var cookie = SurStudioPluginTranslatorRevolutionLiteCommon.Cookie.get("surstudio_plugin_translator_revolution_lite_heading_" + this._id);
	if (cookie == "true" || cookie == "false")
		this._show(cookie == "true", true);
	
};
	
SurStudioPluginTranslatorRevolutionLiteCommon.Heading.prototype._get_next_sibling = function(_reference) {

	var result = _reference.nextSibling;
	while (result != null && result.nodeType != 1)
		result = result.nextSibling;
	
	return result;
	
};
	
SurStudioPluginTranslatorRevolutionLiteCommon.Heading.prototype._set_styles = function() {
		
	SurStudioPluginTranslatorRevolutionLiteCommon.CSS.addClass(this._target, "surstudio_plugin_translator_revolution_lite_heading_enabled");
	
};

SurStudioPluginTranslatorRevolutionLiteCommon.Cookie = {

	get: function(name) {
		var start = document.cookie.indexOf(name+"=");
		var len = start + name.length + 1;
		if ((!start) && (name != document.cookie.substring(0, name.length))) {
			return null;
		}
		if (start == -1) 
			return null;
		var end = document.cookie.indexOf( ';', len );
		if (end == -1) 
			end = document.cookie.length;
		return decodeURIComponent(document.cookie.substring(len, end));
	},

	set: function(name, value, expires, path, domain, secure) {
		var today = new Date();
		today.setTime(today.getTime());

		if (expires)
			expires = expires * 1000 * 60 * 60 * 24;
		
		var expires_date = new Date(today.getTime() + (expires));
		document.cookie = name + '=' + escape(value) +
			((expires) ? ';expires=' + expires_date.toGMTString() : '') + //expires.toGMTString()
			((path) ? ';path=' + path : '') +
			((domain) ? ';domain=' + domain : '') +
			((secure) ? ';secure' : '');
	},

	remove: function(name, path, domain) {
		if (Translator.Common.getCookie(name)) document.cookie = name + '=' +
				((path) ? ';path=' + path : '') +
				((domain) ? ';domain=' + domain : '') +
				';expires=Thu, 01-Jan-1970 00:00:01 GMT';
	}
	
};

SurStudioPluginTranslatorRevolutionLiteCommon.initializeTooltip = function(_target) {

	jQuery(_target).tooltip({
		effect: "slide",
		relative: true,
		direction: "left",
		position: "center left",
		opacity: 0.9
	});

};

SurStudioPluginTranslatorRevolutionLiteCommon.initializeRangeField = function(_options) {
	
	var range_slider = jQuery(_options.container).slider({
		value: _options.value,
		min: _options.min,
		max: _options.max,
		step: _options.step,
		change: function(_event, _ui) {
			jQuery(_options.field).val(_ui.value);
		},
		slide: function(_event, _ui) {
			jQuery(_options.field).val(_ui.value);
		}
	});
	
	jQuery(_options.field).blur(function() {
		var value = Math.floor(Number(this.value)) || this.value !== "0";
		if (value === true)
			value = _options.min;
		if (value <= _options.max && value >= _options.min && value % _options.step == 0)
			range_slider.slider("value", value);
	});

	jQuery(_options.field).keyup(function() {
		var value = Math.floor(Number(this.value)) || this.value !== "0";
		if (value !== true)
			if (value <= _options.max && value >= _options.min && value % _options.step == 0)
				range_slider.slider("value", value);
	});	

};

/* ============= css ================= */

SurStudioPluginTranslatorRevolutionLiteCommon.CSS = {

	hasClass: function(_element, className) { 
		_element = SurStudioPluginTranslatorRevolutionLiteCommon.$(_element);
		if (!_element)
			return;
		if(_element&&className&&_element.className) { 
			return new RegExp('\\b'+SurStudioPluginTranslatorRevolutionLiteCommon.trim(className)+'\\b').test(_element.className);
		}
		return false;
	},
	
	addClass: function(_element, className) {
		_element = SurStudioPluginTranslatorRevolutionLiteCommon.$(_element);
		if (!_element)
			return;
		if(_element&&className) {
			if(!SurStudioPluginTranslatorRevolutionLiteCommon.CSS.hasClass(_element, className)) {
				className = SurStudioPluginTranslatorRevolutionLiteCommon.trim(className);
				if(_element.className) { 
					_element.className += " " + className;
				}
				else { 
					_element.className = className; 
				}
			}
		}
		return this;
	},
	
	removeClass: function(_element, className) {
		_element = SurStudioPluginTranslatorRevolutionLiteCommon.$(_element);
		if (!_element)
			return;
		if(_element&&className&&_element.className) {
			className = SurStudioPluginTranslatorRevolutionLiteCommon.trim(className);
			var regexp = new RegExp("\\b" + className + "\\b","g");
			_element.className = _element.className.replace(regexp,"");
		}
		return this;
	},
		
	conditionClass: function(_element, className, shouldShow) { 
		if(shouldShow) { 
			SurStudioPluginTranslatorRevolutionLiteCommon.CSS.addClass(_element, className);
		}
		else { 
			SurStudioPluginTranslatorRevolutionLiteCommon.CSS.removeClass(_element, className);
		}
	},
		
	chooseClass: function(_element, expression, trueClass, falseClass) { 
		SurStudioPluginTranslatorRevolutionLiteCommon.CSS.conditionClass(_element, trueClass, expression);
		SurStudioPluginTranslatorRevolutionLiteCommon.CSS.conditionClass(_element, falseClass, !expression);
	},
		
	setClass: function(_element, className) { 
		_element = SurStudioPluginTranslatorRevolutionLiteCommon.$(_element);
		if (!_element)
			return;
		_element.className = className;
		return this;
	},
		
	toggleClass: function(_element, className) {
		_element = SurStudioPluginTranslatorRevolutionLiteCommon.$(_element);
		if(SurStudioPluginTranslatorRevolutionLiteCommon.CSS.hasClass(_element, className)) {
			return SurStudioPluginTranslatorRevolutionLiteCommon.CSS.removeClass(_element, className);
		}
		else {
			return SurStudioPluginTranslatorRevolutionLiteCommon.CSS.addClass(_element, className);
		}
	},
		
	setStyle: function(_element, name, value) {
		if (!_element)
			return;
		_element.style[name] = value;
		return _element;
	}

};

SurStudioPluginTranslatorRevolutionLiteCommon.Tabs = function(level) {
	
	this.tabs = [];
	this.level = typeof level == "undefined" ? 0 : level;

};

SurStudioPluginTranslatorRevolutionLiteCommon.Tabs.prototype.registerTab = function(param, callback) {
	
	var target = SurStudioPluginTranslatorRevolutionLiteCommon.$(param + "_menu");
	
	if (!target)
		return;
	
	target._owner = this;
	
	SurStudioPluginTranslatorRevolutionLiteCommon.addEvent(SurStudioPluginTranslatorRevolutionLiteCommon.$(param + "_menu"), "click", function(e) {

		var owner = SurStudioPluginTranslatorRevolutionLiteCommon.getOwnerParent(SurStudioPluginTranslatorRevolutionLiteCommon.getOwner(e));
		owner._owner.selectTab(param);
		
		if (typeof callback != "undefined")
			callback(param);
		
	}, false);
	
	this.tabs.push(param);

};

SurStudioPluginTranslatorRevolutionLiteCommon.Tabs.prototype.selectTab = function(name) {

	for(var i=0; i<this.tabs.length; i++) {
		this.displayTab(this.tabs[i], name == this.tabs[i]);
		this.selectMenu(this.tabs[i], false);
	}

	this.selectMenu(name, true);

	this.setField(name);

};

SurStudioPluginTranslatorRevolutionLiteCommon.Tabs.prototype.setField = function(name) {
	
	var aux = this.level !== 0 ? "_" + this.level : "";
	SurStudioPluginTranslatorRevolutionLiteCommon.$("surstudio_tab" + aux).value = name;
	
};

SurStudioPluginTranslatorRevolutionLiteCommon.Tabs.prototype.getSelected = function() {
	
	for(var i=0; i<this.tabs.length; i++) 
		if(SurStudioPluginTranslatorRevolutionLiteCommon.CSS.hasClass(this.tabs[i] + "_menu", "surstudio_plugin_translator_revolution_lite_ui_tab_selected")) 
			return this.tabs[i];
	
	return "";
};

SurStudioPluginTranslatorRevolutionLiteCommon.Tabs.prototype.displayTab = function(name, state) {
/*
	if (state)
		jQuery("#" + name + "_tab").fadeIn("fast");
	else
		jQuery("#" + name + "_tab").hide();
*/
	SurStudioPluginTranslatorRevolutionLiteCommon.CSS.chooseClass(SurStudioPluginTranslatorRevolutionLiteCommon.$(name + "_tab"), state, "surstudio_plugin_translator_revolution_lite_display", "surstudio_plugin_translator_revolution_lite_no_display");

};

SurStudioPluginTranslatorRevolutionLiteCommon.Tabs.prototype.selectMenu = function(name, state) {

	SurStudioPluginTranslatorRevolutionLiteCommon.CSS.chooseClass(SurStudioPluginTranslatorRevolutionLiteCommon.$(name + "_menu"), state, "surstudio_plugin_translator_revolution_lite_ui_tab_selected", "surstudio_plugin_translator_revolution_lite_ui_tab_unselected");

};

/*!
 * jQuery UI Widget 1.8.15
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Widget
 */
(function(b,j){if(b.cleanData){var k=b.cleanData;b.cleanData=function(a){for(var c=0,d;(d=a[c])!=null;c++)b(d).triggerHandler("remove");k(a)}}else{var l=b.fn.remove;b.fn.remove=function(a,c){return this.each(function(){if(!c)if(!a||b.filter(a,[this]).length)b("*",this).add([this]).each(function(){b(this).triggerHandler("remove")});return l.call(b(this),a,c)})}}b.widget=function(a,c,d){var e=a.split(".")[0],f;a=a.split(".")[1];f=e+"-"+a;if(!d){d=c;c=b.Widget}b.expr[":"][f]=function(h){return!!b.data(h,
a)};b[e]=b[e]||{};b[e][a]=function(h,g){arguments.length&&this._createWidget(h,g)};c=new c;c.options=b.extend(true,{},c.options);b[e][a].prototype=b.extend(true,c,{namespace:e,widgetName:a,widgetEventPrefix:b[e][a].prototype.widgetEventPrefix||a,widgetBaseClass:f},d);b.widget.bridge(a,b[e][a])};b.widget.bridge=function(a,c){b.fn[a]=function(d){var e=typeof d==="string",f=Array.prototype.slice.call(arguments,1),h=this;d=!e&&f.length?b.extend.apply(null,[true,d].concat(f)):d;if(e&&d.charAt(0)==="_")return h;
e?this.each(function(){var g=b.data(this,a),i=g&&b.isFunction(g[d])?g[d].apply(g,f):g;if(i!==g&&i!==j){h=i;return false}}):this.each(function(){var g=b.data(this,a);g?g.option(d||{})._init():b.data(this,a,new c(d,this))});return h}};b.Widget=function(a,c){arguments.length&&this._createWidget(a,c)};b.Widget.prototype={widgetName:"widget",widgetEventPrefix:"",options:{disabled:false},_createWidget:function(a,c){b.data(c,this.widgetName,this);this.element=b(c);this.options=b.extend(true,{},this.options,
this._getCreateOptions(),a);var d=this;this.element.bind("remove."+this.widgetName,function(){d.destroy()});this._create();this._trigger("create");this._init()},_getCreateOptions:function(){return b.metadata&&b.metadata.get(this.element[0])[this.widgetName]},_create:function(){},_init:function(){},destroy:function(){this.element.unbind("."+this.widgetName).removeData(this.widgetName);this.widget().unbind("."+this.widgetName).removeAttr("aria-disabled").removeClass(this.widgetBaseClass+"-disabled ui-state-disabled")},
widget:function(){return this.element},option:function(a,c){var d=a;if(arguments.length===0)return b.extend({},this.options);if(typeof a==="string"){if(c===j)return this.options[a];d={};d[a]=c}this._setOptions(d);return this},_setOptions:function(a){var c=this;b.each(a,function(d,e){c._setOption(d,e)});return this},_setOption:function(a,c){this.options[a]=c;if(a==="disabled")this.widget()[c?"addClass":"removeClass"](this.widgetBaseClass+"-disabled ui-state-disabled").attr("aria-disabled",c);return this},
enable:function(){return this._setOption("disabled",false)},disable:function(){return this._setOption("disabled",true)},_trigger:function(a,c,d){var e=this.options[a];c=b.Event(c);c.type=(a===this.widgetEventPrefix?a:this.widgetEventPrefix+a).toLowerCase();d=d||{};if(c.originalEvent){a=b.event.props.length;for(var f;a;){f=b.event.props[--a];c[f]=c.originalEvent[f]}}this.element.trigger(c,d);return!(b.isFunction(e)&&e.call(this.element[0],c,d)===false||c.isDefaultPrevented())}}})(jQuery);
;/*!
 * jQuery UI Mouse 1.8.15
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Mouse
 *
 * Depends:
 *	jquery.ui.widget.js
 */
(function(b){b.widget("ui.mouse",{options:{cancel:":input,option",distance:1,delay:0},_mouseInit:function(){var a=this;this.element.bind("mousedown."+this.widgetName,function(c){return a._mouseDown(c)}).bind("click."+this.widgetName,function(c){if(true===b.data(c.target,a.widgetName+".preventClickEvent")){b.removeData(c.target,a.widgetName+".preventClickEvent");c.stopImmediatePropagation();return false}});this.started=false},_mouseDestroy:function(){this.element.unbind("."+this.widgetName)},_mouseDown:function(a){a.originalEvent=
a.originalEvent||{};if(!a.originalEvent.mouseHandled){this._mouseStarted&&this._mouseUp(a);this._mouseDownEvent=a;var c=this,e=a.which==1,f=typeof this.options.cancel=="string"?b(a.target).closest(this.options.cancel).length:false;if(!e||f||!this._mouseCapture(a))return true;this.mouseDelayMet=!this.options.delay;if(!this.mouseDelayMet)this._mouseDelayTimer=setTimeout(function(){c.mouseDelayMet=true},this.options.delay);if(this._mouseDistanceMet(a)&&this._mouseDelayMet(a)){this._mouseStarted=this._mouseStart(a)!==
false;if(!this._mouseStarted){a.preventDefault();return true}}true===b.data(a.target,this.widgetName+".preventClickEvent")&&b.removeData(a.target,this.widgetName+".preventClickEvent");this._mouseMoveDelegate=function(d){return c._mouseMove(d)};this._mouseUpDelegate=function(d){return c._mouseUp(d)};b(document).bind("mousemove."+this.widgetName,this._mouseMoveDelegate).bind("mouseup."+this.widgetName,this._mouseUpDelegate);a.preventDefault();return a.originalEvent.mouseHandled=true}},_mouseMove:function(a){if(b.browser.msie&&
!(document.documentMode>=9)&&!a.button)return this._mouseUp(a);if(this._mouseStarted){this._mouseDrag(a);return a.preventDefault()}if(this._mouseDistanceMet(a)&&this._mouseDelayMet(a))(this._mouseStarted=this._mouseStart(this._mouseDownEvent,a)!==false)?this._mouseDrag(a):this._mouseUp(a);return!this._mouseStarted},_mouseUp:function(a){b(document).unbind("mousemove."+this.widgetName,this._mouseMoveDelegate).unbind("mouseup."+this.widgetName,this._mouseUpDelegate);if(this._mouseStarted){this._mouseStarted=
false;a.target==this._mouseDownEvent.target&&b.data(a.target,this.widgetName+".preventClickEvent",true);this._mouseStop(a)}return false},_mouseDistanceMet:function(a){return Math.max(Math.abs(this._mouseDownEvent.pageX-a.pageX),Math.abs(this._mouseDownEvent.pageY-a.pageY))>=this.options.distance},_mouseDelayMet:function(){return this.mouseDelayMet},_mouseStart:function(){},_mouseDrag:function(){},_mouseStop:function(){},_mouseCapture:function(){return true}})})(jQuery);
;

/*
 * jQuery UI Slider 1.8.15
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Slider
 *
 * Depends:
 *	jquery.ui.core.js
 *	jquery.ui.mouse.js
 *	jquery.ui.widget.js
 */
(function(d){d.widget("ui.slider",d.ui.mouse,{widgetEventPrefix:"slide",options:{animate:false,distance:0,max:100,min:0,orientation:"horizontal",range:false,step:1,value:0,values:null},_create:function(){var a=this,b=this.options,c=this.element.find(".ui-slider-handle").addClass("ui-state-default ui-corner-all"),f=b.values&&b.values.length||1,e=[];this._mouseSliding=this._keySliding=false;this._animateOff=true;this._handleIndex=null;this._detectOrientation();this._mouseInit();this.element.addClass("ui-slider ui-slider-"+
this.orientation+" ui-widget ui-widget-content ui-corner-all"+(b.disabled?" ui-slider-disabled ui-disabled":""));this.range=d([]);if(b.range){if(b.range===true){if(!b.values)b.values=[this._valueMin(),this._valueMin()];if(b.values.length&&b.values.length!==2)b.values=[b.values[0],b.values[0]]}this.range=d("<div></div>").appendTo(this.element).addClass("ui-slider-range ui-widget-header"+(b.range==="min"||b.range==="max"?" ui-slider-range-"+b.range:""))}for(var j=c.length;j<f;j+=1)e.push("<a class='ui-slider-handle ui-state-default ui-corner-all' href='#'></a>");
this.handles=c.add(d(e.join("")).appendTo(a.element));this.handle=this.handles.eq(0);this.handles.add(this.range).filter("a").click(function(g){g.preventDefault()}).hover(function(){b.disabled||d(this).addClass("ui-state-hover")},function(){d(this).removeClass("ui-state-hover")}).focus(function(){if(b.disabled)d(this).blur();else{d(".ui-slider .ui-state-focus").removeClass("ui-state-focus");d(this).addClass("ui-state-focus")}}).blur(function(){d(this).removeClass("ui-state-focus")});this.handles.each(function(g){d(this).data("index.ui-slider-handle",
g)});this.handles.keydown(function(g){var k=true,l=d(this).data("index.ui-slider-handle"),i,h,m;if(!a.options.disabled){switch(g.keyCode){case d.ui.keyCode.HOME:case d.ui.keyCode.END:case d.ui.keyCode.PAGE_UP:case d.ui.keyCode.PAGE_DOWN:case d.ui.keyCode.UP:case d.ui.keyCode.RIGHT:case d.ui.keyCode.DOWN:case d.ui.keyCode.LEFT:k=false;if(!a._keySliding){a._keySliding=true;d(this).addClass("ui-state-active");i=a._start(g,l);if(i===false)return}break}m=a.options.step;i=a.options.values&&a.options.values.length?
(h=a.values(l)):(h=a.value());switch(g.keyCode){case d.ui.keyCode.HOME:h=a._valueMin();break;case d.ui.keyCode.END:h=a._valueMax();break;case d.ui.keyCode.PAGE_UP:h=a._trimAlignValue(i+(a._valueMax()-a._valueMin())/5);break;case d.ui.keyCode.PAGE_DOWN:h=a._trimAlignValue(i-(a._valueMax()-a._valueMin())/5);break;case d.ui.keyCode.UP:case d.ui.keyCode.RIGHT:if(i===a._valueMax())return;h=a._trimAlignValue(i+m);break;case d.ui.keyCode.DOWN:case d.ui.keyCode.LEFT:if(i===a._valueMin())return;h=a._trimAlignValue(i-
m);break}a._slide(g,l,h);return k}}).keyup(function(g){var k=d(this).data("index.ui-slider-handle");if(a._keySliding){a._keySliding=false;a._stop(g,k);a._change(g,k);d(this).removeClass("ui-state-active")}});this._refreshValue();this._animateOff=false},destroy:function(){this.handles.remove();this.range.remove();this.element.removeClass("ui-slider ui-slider-horizontal ui-slider-vertical ui-slider-disabled ui-widget ui-widget-content ui-corner-all").removeData("slider").unbind(".slider");this._mouseDestroy();
return this},_mouseCapture:function(a){var b=this.options,c,f,e,j,g;if(b.disabled)return false;this.elementSize={width:this.element.outerWidth(),height:this.element.outerHeight()};this.elementOffset=this.element.offset();c=this._normValueFromMouse({x:a.pageX,y:a.pageY});f=this._valueMax()-this._valueMin()+1;j=this;this.handles.each(function(k){var l=Math.abs(c-j.values(k));if(f>l){f=l;e=d(this);g=k}});if(b.range===true&&this.values(1)===b.min){g+=1;e=d(this.handles[g])}if(this._start(a,g)===false)return false;
this._mouseSliding=true;j._handleIndex=g;e.addClass("ui-state-active").focus();b=e.offset();this._clickOffset=!d(a.target).parents().andSelf().is(".ui-slider-handle")?{left:0,top:0}:{left:a.pageX-b.left-e.width()/2,top:a.pageY-b.top-e.height()/2-(parseInt(e.css("borderTopWidth"),10)||0)-(parseInt(e.css("borderBottomWidth"),10)||0)+(parseInt(e.css("marginTop"),10)||0)};this.handles.hasClass("ui-state-hover")||this._slide(a,g,c);return this._animateOff=true},_mouseStart:function(){return true},_mouseDrag:function(a){var b=
this._normValueFromMouse({x:a.pageX,y:a.pageY});this._slide(a,this._handleIndex,b);return false},_mouseStop:function(a){this.handles.removeClass("ui-state-active");this._mouseSliding=false;this._stop(a,this._handleIndex);this._change(a,this._handleIndex);this._clickOffset=this._handleIndex=null;return this._animateOff=false},_detectOrientation:function(){this.orientation=this.options.orientation==="vertical"?"vertical":"horizontal"},_normValueFromMouse:function(a){var b;if(this.orientation==="horizontal"){b=
this.elementSize.width;a=a.x-this.elementOffset.left-(this._clickOffset?this._clickOffset.left:0)}else{b=this.elementSize.height;a=a.y-this.elementOffset.top-(this._clickOffset?this._clickOffset.top:0)}b=a/b;if(b>1)b=1;if(b<0)b=0;if(this.orientation==="vertical")b=1-b;a=this._valueMax()-this._valueMin();return this._trimAlignValue(this._valueMin()+b*a)},_start:function(a,b){var c={handle:this.handles[b],value:this.value()};if(this.options.values&&this.options.values.length){c.value=this.values(b);
c.values=this.values()}return this._trigger("start",a,c)},_slide:function(a,b,c){var f;if(this.options.values&&this.options.values.length){f=this.values(b?0:1);if(this.options.values.length===2&&this.options.range===true&&(b===0&&c>f||b===1&&c<f))c=f;if(c!==this.values(b)){f=this.values();f[b]=c;a=this._trigger("slide",a,{handle:this.handles[b],value:c,values:f});this.values(b?0:1);a!==false&&this.values(b,c,true)}}else if(c!==this.value()){a=this._trigger("slide",a,{handle:this.handles[b],value:c});
a!==false&&this.value(c)}},_stop:function(a,b){var c={handle:this.handles[b],value:this.value()};if(this.options.values&&this.options.values.length){c.value=this.values(b);c.values=this.values()}this._trigger("stop",a,c)},_change:function(a,b){if(!this._keySliding&&!this._mouseSliding){var c={handle:this.handles[b],value:this.value()};if(this.options.values&&this.options.values.length){c.value=this.values(b);c.values=this.values()}this._trigger("change",a,c)}},value:function(a){if(arguments.length){this.options.value=
this._trimAlignValue(a);this._refreshValue();this._change(null,0)}else return this._value()},values:function(a,b){var c,f,e;if(arguments.length>1){this.options.values[a]=this._trimAlignValue(b);this._refreshValue();this._change(null,a)}else if(arguments.length)if(d.isArray(arguments[0])){c=this.options.values;f=arguments[0];for(e=0;e<c.length;e+=1){c[e]=this._trimAlignValue(f[e]);this._change(null,e)}this._refreshValue()}else return this.options.values&&this.options.values.length?this._values(a):
this.value();else return this._values()},_setOption:function(a,b){var c,f=0;if(d.isArray(this.options.values))f=this.options.values.length;d.Widget.prototype._setOption.apply(this,arguments);switch(a){case "disabled":if(b){this.handles.filter(".ui-state-focus").blur();this.handles.removeClass("ui-state-hover");this.handles.propAttr("disabled",true);this.element.addClass("ui-disabled")}else{this.handles.propAttr("disabled",false);this.element.removeClass("ui-disabled")}break;case "orientation":this._detectOrientation();
this.element.removeClass("ui-slider-horizontal ui-slider-vertical").addClass("ui-slider-"+this.orientation);this._refreshValue();break;case "value":this._animateOff=true;this._refreshValue();this._change(null,0);this._animateOff=false;break;case "values":this._animateOff=true;this._refreshValue();for(c=0;c<f;c+=1)this._change(null,c);this._animateOff=false;break}},_value:function(){var a=this.options.value;return a=this._trimAlignValue(a)},_values:function(a){var b,c;if(arguments.length){b=this.options.values[a];
return b=this._trimAlignValue(b)}else{b=this.options.values.slice();for(c=0;c<b.length;c+=1)b[c]=this._trimAlignValue(b[c]);return b}},_trimAlignValue:function(a){if(a<=this._valueMin())return this._valueMin();if(a>=this._valueMax())return this._valueMax();var b=this.options.step>0?this.options.step:1,c=(a-this._valueMin())%b;a=a-c;if(Math.abs(c)*2>=b)a+=c>0?b:-b;return parseFloat(a.toFixed(5))},_valueMin:function(){return this.options.min},_valueMax:function(){return this.options.max},_refreshValue:function(){var a=
this.options.range,b=this.options,c=this,f=!this._animateOff?b.animate:false,e,j={},g,k,l,i;if(this.options.values&&this.options.values.length)this.handles.each(function(h){e=(c.values(h)-c._valueMin())/(c._valueMax()-c._valueMin())*100;j[c.orientation==="horizontal"?"left":"bottom"]=e+"%";d(this).stop(1,1)[f?"animate":"css"](j,b.animate);if(c.options.range===true)if(c.orientation==="horizontal"){if(h===0)c.range.stop(1,1)[f?"animate":"css"]({left:e+"%"},b.animate);if(h===1)c.range[f?"animate":"css"]({width:e-
g+"%"},{queue:false,duration:b.animate})}else{if(h===0)c.range.stop(1,1)[f?"animate":"css"]({bottom:e+"%"},b.animate);if(h===1)c.range[f?"animate":"css"]({height:e-g+"%"},{queue:false,duration:b.animate})}g=e});else{k=this.value();l=this._valueMin();i=this._valueMax();e=i!==l?(k-l)/(i-l)*100:0;j[c.orientation==="horizontal"?"left":"bottom"]=e+"%";this.handle.stop(1,1)[f?"animate":"css"](j,b.animate);if(a==="min"&&this.orientation==="horizontal")this.range.stop(1,1)[f?"animate":"css"]({width:e+"%"},
b.animate);if(a==="max"&&this.orientation==="horizontal")this.range[f?"animate":"css"]({width:100-e+"%"},{queue:false,duration:b.animate});if(a==="min"&&this.orientation==="vertical")this.range.stop(1,1)[f?"animate":"css"]({height:e+"%"},b.animate);if(a==="max"&&this.orientation==="vertical")this.range[f?"animate":"css"]({height:100-e+"%"},{queue:false,duration:b.animate})}}});d.extend(d.ui.slider,{version:"1.8.15"})})(jQuery);
;

/*!
 * jQuery Tools dev - The missing UI library for the Web
 * 
 * tooltip/tooltip.js
 * tooltip/tooltip.dynamic.js
 * tooltip/tooltip.slide.js
 * 
 * NO COPYRIGHTS OR LICENSES. DO WHAT YOU LIKE.
 * 
 * http://flowplayer.org/tools/
 * 
 */
(function(a){a.tools=a.tools||{version:"dev"},a.tools.tooltip={conf:{effect:"toggle",fadeOutSpeed:"fast",predelay:0,delay:30,opacity:1,tip:0,fadeIE:!1,position:["top","center"],offset:[0,0],relative:!1,cancelDefault:!0,events:{def:"mouseenter,mouseleave",input:"focus,blur",widget:"focus mouseenter,blur mouseleave",tooltip:"mouseenter,mouseleave"},layout:"<div/>",tipClass:"tooltip"},addEffect:function(a,c,d){b[a]=[c,d]}};var b={toggle:[function(a){var b=this.getConf(),c=this.getTip(),d=b.opacity;d<1&&c.css({opacity:d}),c.show(),a.call()},function(a){this.getTip().hide(),a.call()}],fade:[function(b){var c=this.getConf();!a.browser.msie||c.fadeIE?this.getTip().fadeTo(c.fadeInSpeed,c.opacity,b):(this.getTip().show(),b())},function(b){var c=this.getConf();!a.browser.msie||c.fadeIE?this.getTip().fadeOut(c.fadeOutSpeed,b):(this.getTip().hide(),b())}]};function c(b,c,d){var e=d.relative?b.position().top:b.offset().top,f=d.relative?b.position().left:b.offset().left,g=d.position[0];e-=c.outerHeight()-d.offset[0],f+=b.outerWidth()+d.offset[1],/iPad/i.test(navigator.userAgent)&&(e-=a(window).scrollTop());var h=c.outerHeight()+b.outerHeight();g=="center"&&(e+=h/2),g=="bottom"&&(e+=h),g=d.position[1];var i=c.outerWidth()+b.outerWidth();g=="center"&&(f-=i/2),g=="left"&&(f-=i);return{top:e,left:f}}function d(d,e){var f=this,g=d.add(f),h,i=0,j=0,k=d.attr("title"),l=d.attr("data-tooltip"),m=b[e.effect],n,o=d.is(":input"),p=o&&d.is(":checkbox, :radio, select, :button, :submit"),q=d.attr("type"),r=e.events[q]||e.events[o?p?"widget":"input":"def"];if(!m)throw"Nonexistent effect \""+e.effect+"\"";r=r.split(/,\s*/);if(r.length!=2)throw"Tooltip: bad events configuration for "+q;d.bind(r[0],function(a){clearTimeout(i),e.predelay?j=setTimeout(function(){f.show(a)},e.predelay):f.show(a)}).bind(r[1],function(a){clearTimeout(j),e.delay?i=setTimeout(function(){f.hide(a)},e.delay):f.hide(a)}),k&&e.cancelDefault&&(d.removeAttr("title"),d.data("title",k)),a.extend(f,{show:function(b){if(!h){l?h=a(l):e.tip?h=a(e.tip).eq(0):k?h=a(e.layout).addClass(e.tipClass).appendTo(document.body).hide().append(k):(h=d.next(),h.length||(h=d.parent().next()));if(!h.length)throw"Cannot find tooltip for "+d}if(f.isShown())return f;h.stop(!0,!0);var o=c(d,h,e);e.tip&&h.html(d.data("title")),b=a.Event(),b.type="onBeforeShow",g.trigger(b,[o]);if(b.isDefaultPrevented())return f;o=c(d,h,e),h.css({position:"absolute",top:o.top,left:o.left}),n=!0,m[0].call(f,function(){b.type="onShow",n="full",g.trigger(b)});var p=e.events.tooltip.split(/,\s*/);h.data("__set")||(h.unbind(p[0]).bind(p[0],function(){clearTimeout(i),clearTimeout(j)}),p[1]&&!d.is("input:not(:checkbox, :radio), textarea")&&h.unbind(p[1]).bind(p[1],function(a){a.relatedTarget!=d[0]&&d.trigger(r[1].split(" ")[0])}),e.tip||h.data("__set",!0));return f},hide:function(c){if(!h||!f.isShown())return f;c=a.Event(),c.type="onBeforeHide",g.trigger(c);if(!c.isDefaultPrevented()){n=!1,b[e.effect][1].call(f,function(){c.type="onHide",g.trigger(c)});return f}},isShown:function(a){return a?n=="full":n},getConf:function(){return e},getTip:function(){return h},getTrigger:function(){return d}}),a.each("onHide,onBeforeShow,onShow,onBeforeHide".split(","),function(b,c){a.isFunction(e[c])&&a(f).bind(c,e[c]),f[c]=function(b){b&&a(f).bind(c,b);return f}})}a.fn.tooltip=function(b){var c=this.data("tooltip");if(c)return c;b=a.extend(!0,{},a.tools.tooltip.conf,b),typeof b.position=="string"&&(b.position=b.position.split(/,?\s/)),this.each(function(){c=new d(a(this),b),a(this).data("tooltip",c)});return b.api?c:this}})(jQuery);
(function(a){var b=a.tools.tooltip;b.dynamic={conf:{classNames:"top right bottom left"}};function c(b){var c=a(window),d=c.width()+c.scrollLeft(),e=c.height()+c.scrollTop();return[b.offset().top<=c.scrollTop(),d<=b.offset().left+b.width(),e<=b.offset().top+b.height(),c.scrollLeft()>=b.offset().left]}function d(a){var b=a.length;while(b--)if(a[b])return!1;return!0}a.fn.dynamic=function(e){typeof e=="number"&&(e={speed:e}),e=a.extend({},b.dynamic.conf,e);var f=e.classNames.split(/\s/),g;this.each(function(){var b=a(this).tooltip().onBeforeShow(function(b,h){var i=this.getTip(),j=this.getConf();g||(g=[j.position[0],j.position[1],j.offset[0],j.offset[1],a.extend({},j)]),a.extend(j,g[4]),j.position=[g[0],g[1]],j.offset=[g[2],g[3]],i.css({visibility:"hidden",position:"absolute",top:h.top,left:h.left}).show();var k=c(i);if(!d(k)){k[2]&&(a.extend(j,e.top),j.position[0]="top",i.addClass(f[0])),k[3]&&(a.extend(j,e.right),j.position[1]="right",i.addClass(f[1])),k[0]&&(a.extend(j,e.bottom),j.position[0]="bottom",i.addClass(f[2])),k[1]&&(a.extend(j,e.left),j.position[1]="left",i.addClass(f[3]));if(k[0]||k[2])j.offset[0]*=-1;if(k[1]||k[3])j.offset[1]*=-1}i.css({visibility:"visible"}).hide()});b.onBeforeShow(function(){var a=this.getConf(),b=this.getTip();setTimeout(function(){a.position=[g[0],g[1]],a.offset=[g[2],g[3]]},0)}),b.onHide(function(){var a=this.getTip();a.removeClass(e.classNames)}),ret=b});return e.api?ret:this}})(jQuery);
(function(a){var b=a.tools.tooltip;a.extend(b.conf,{direction:"up",bounce:!1,slideOffset:10,slideInSpeed:200,slideOutSpeed:200,slideFade:!a.browser.msie});var c={up:["-","top"],down:["+","top"],left:["-","left"],right:["+","left"]};b.addEffect("slide",function(a){var b=this.getConf(),d=this.getTip(),e=b.slideFade?{opacity:b.opacity}:{},f=c[b.direction]||c.up;e[f[1]]=f[0]+"="+b.slideOffset,b.slideFade&&d.css({opacity:0}),d.show().animate(e,b.slideInSpeed,a)},function(b){var d=this.getConf(),e=d.slideOffset,f=d.slideFade?{opacity:0}:{},g=c[d.direction]||c.up,h=""+g[0];d.bounce&&(h=h=="+"?"-":"+"),f[g[1]]=h+"="+e,this.getTip().animate(f,d.slideOutSpeed,function(){a(this).hide(),b.call()})})})(jQuery);

// jQuery List DragSort v0.4.3
// License: http://dragsort.codeplex.com/license
(function(b){b.fn.dragsort=function(k){var d=b.extend({},b.fn.dragsort.defaults,k),g=[],a=null,j=null;this.selector&&b("head").append("<style type='text/css'>"+(this.selector.split(",").join(" "+d.dragSelector+",")+" "+d.dragSelector)+" { cursor: move; }</style>");this.each(function(k,i){b(i).is("table")&&b(i).children().size()==1&&b(i).children().is("tbody")&&(i=b(i).children().get(0));var m={draggedItem:null,placeHolderItem:null,pos:null,offset:null,offsetLimit:null,scroll:null,container:i,init:function(){b(this.container).attr("data-listIdx", k).mousedown(this.grabItem).find(d.dragSelector).css("cursor","move");b(this.container).children(d.itemSelector).each(function(a){b(this).attr("data-itemIdx",a)})},grabItem:function(e){if(!(e.which!=1||b(e.target).is(d.dragSelectorExclude))){for(var c=e.target;!b(c).is("[data-listIdx='"+b(this).attr("data-listIdx")+"'] "+d.dragSelector);){if(c==this)return;c=c.parentNode}a!=null&&a.draggedItem!=null&&a.dropItem();b(e.target).css("cursor","move");a=g[b(this).attr("data-listIdx")];a.draggedItem= b(c).closest(d.itemSelector);var c=parseInt(a.draggedItem.css("marginTop")),f=parseInt(a.draggedItem.css("marginLeft"));a.offset=a.draggedItem.offset();a.offset.top=e.pageY-a.offset.top+(isNaN(c)?0:c)-1;a.offset.left=e.pageX-a.offset.left+(isNaN(f)?0:f)-1;if(!d.dragBetween)c=b(a.container).outerHeight()==0?Math.max(1,Math.round(0.5+b(a.container).children(d.itemSelector).size()*a.draggedItem.outerWidth()/b(a.container).outerWidth()))*a.draggedItem.outerHeight():b(a.container).outerHeight(),a.offsetLimit= b(a.container).offset(),a.offsetLimit.right=a.offsetLimit.left+b(a.container).outerWidth()-a.draggedItem.outerWidth(),a.offsetLimit.bottom=a.offsetLimit.top+c-a.draggedItem.outerHeight();var c=a.draggedItem.height(),f=a.draggedItem.width(),h=a.draggedItem.attr("style");if(jQuery.browser.msie)f=f+2;a.draggedItem.attr("data-origStyle",h?h:"");d.itemSelector=="tr"?(a.draggedItem.children().each(function(){b(this).width(b(this).width())}),a.placeHolderItem=a.draggedItem.clone().attr("data-placeHolder",!0),a.draggedItem.after(a.placeHolderItem), a.placeHolderItem.children().each(function(){b(this).css({borderWidth:0,width:b(this).width()+1,height:b(this).height()+1}).html("&nbsp;")})):(a.draggedItem.after(d.placeHolderTemplate),a.placeHolderItem=a.draggedItem.next().css({height:c,width:f}).attr("data-placeHolder",!0));a.draggedItem.css({position:"absolute",opacity:0.8,"z-index":999,height:c,width:f});b(g).each(function(a,b){b.createDropTargets();b.buildPositionTable()});a.scroll={moveX:0,moveY:0,maxX:b(document).width()-b(window).width(), maxY:b(document).height()-b(window).height()};a.scroll.scrollY=window.setInterval(function(){if(d.scrollContainer!=window)b(d.scrollContainer).scrollTop(b(d.scrollContainer).scrollTop()+a.scroll.moveY);else{var c=b(d.scrollContainer).scrollTop();if(a.scroll.moveY>0&&c<a.scroll.maxY||a.scroll.moveY<0&&c>0)b(d.scrollContainer).scrollTop(c+a.scroll.moveY),a.draggedItem.css("top",a.draggedItem.offset().top+a.scroll.moveY+1)}},10);a.scroll.scrollX=window.setInterval(function(){if(d.scrollContainer!=window)b(d.scrollContainer).scrollLeft(b(d.scrollContainer).scrollLeft()+ a.scroll.moveX);else{var c=b(d.scrollContainer).scrollLeft();if(a.scroll.moveX>0&&c<a.scroll.maxX||a.scroll.moveX<0&&c>0)b(d.scrollContainer).scrollLeft(c+a.scroll.moveX),a.draggedItem.css("left",a.draggedItem.offset().left+a.scroll.moveX+1)}},10);a.setPos(e.pageX,e.pageY);b(document).bind("selectstart",a.stopBubble);b(document).bind("mousemove",a.swapItems);b(document).bind("mouseup",a.dropItem);d.scrollContainer!=window&&b(window).bind("DOMMouseScroll mousewheel",a.wheel);return!1}},setPos:function(e, c){var f=c-this.offset.top,h=e-this.offset.left;d.dragBetween||(f=Math.min(this.offsetLimit.bottom,Math.max(f,this.offsetLimit.top)),h=Math.min(this.offsetLimit.right,Math.max(h,this.offsetLimit.left)));this.draggedItem.parents().each(function(){if(b(this).css("position")!="static"&&(!b.browser.mozilla||b(this).css("display")!="table")){var a=b(this).offset();f-=a.top;h-=a.left;return!1}});if(d.scrollContainer==window)c-=b(window).scrollTop(),e-=b(window).scrollLeft(),c=Math.max(0,c-b(window).height()+ 5)+Math.min(0,c-5),e=Math.max(0,e-b(window).width()+5)+Math.min(0,e-5);else var l=b(d.scrollContainer),g=l.offset(),c=Math.max(0,c-l.height()-g.top)+Math.min(0,c-g.top),e=Math.max(0,e-l.width()-g.left)+Math.min(0,e-g.left);a.scroll.moveX=e==0?0:e*d.scrollSpeed/Math.abs(e);a.scroll.moveY=c==0?0:c*d.scrollSpeed/Math.abs(c);this.draggedItem.css({top:f,left:h})},wheel:function(e){if((b.browser.safari||b.browser.mozilla)&&a&&d.scrollContainer!=window){var c=b(d.scrollContainer),f=c.offset();e.pageX>f.left&& e.pageX<f.left+c.width()&&e.pageY>f.top&&e.pageY<f.top+c.height()&&(f=e.detail?e.detail*5:e.wheelDelta/-2,c.scrollTop(c.scrollTop()+f),e.preventDefault())}},buildPositionTable:function(){var a=this.draggedItem==null?null:this.draggedItem.get(0),c=[];b(this.container).children(d.itemSelector).each(function(d,h){if(h!=a){var g=b(h).offset();g.right=g.left+b(h).width();g.bottom=g.top+b(h).height();g.elm=h;c.push(g)}});this.pos=c},dropItem:function(){if(a.draggedItem!=null){b(a.container).find(d.dragSelector).css("cursor", "move");a.placeHolderItem.before(a.draggedItem);var e=a.draggedItem.attr("data-origStyle");a.draggedItem.attr("style",e);e==""&&a.draggedItem.removeAttr("style");a.draggedItem.removeAttr("data-origStyle");a.placeHolderItem.remove();b("[data-dropTarget]").remove();window.clearInterval(a.scroll.scrollY);window.clearInterval(a.scroll.scrollX);var c=!1;b(g).each(function(){b(this.container).children(d.itemSelector).each(function(a){parseInt(b(this).attr("data-itemIdx"))!=a&&(c=!0,b(this).attr("data-itemIdx", a))})});c&&d.dragEnd.apply(a.draggedItem);a.draggedItem=null;b(document).unbind("selectstart",a.stopBubble);b(document).unbind("mousemove",a.swapItems);b(document).unbind("mouseup",a.dropItem);d.scrollContainer!=window&&b(window).unbind("DOMMouseScroll mousewheel",a.wheel);return!1}},stopBubble:function(){return!1},swapItems:function(e){if(a.draggedItem==null)return!1;a.setPos(e.pageX,e.pageY);for(var c=a.findPos(e.pageX,e.pageY),f=a,h=0;c==-1&&d.dragBetween&&h<g.length;h++)c=g[h].findPos(e.pageX, e.pageY),f=g[h];if(c==-1||b(f.pos[c].elm).attr("data-placeHolder"))return!1;j==null||j.top>a.draggedItem.offset().top||j.left>a.draggedItem.offset().left?b(f.pos[c].elm).before(a.placeHolderItem):b(f.pos[c].elm).after(a.placeHolderItem);b(g).each(function(a,b){b.createDropTargets();b.buildPositionTable()});j=a.draggedItem.offset();return!1},findPos:function(a,b){for(var d=0;d<this.pos.length;d++)if(this.pos[d].left<a&&this.pos[d].right>a&&this.pos[d].top<b&&this.pos[d].bottom>b)return d;return-1}, createDropTargets:function(){d.dragBetween&&b(g).each(function(){var d=b(this.container).find("[data-placeHolder]"),c=b(this.container).find("[data-dropTarget]");d.size()>0&&c.size()>0?c.remove():d.size()==0&&c.size()==0&&(b(this.container).append(a.placeHolderItem.removeAttr("data-placeHolder").clone().attr("data-dropTarget",!0)),a.placeHolderItem.attr("data-placeHolder",!0))})}};m.init();g.push(m)});return this};b.fn.dragsort.defaults={itemSelector:"li",dragSelector:"li",dragSelectorExclude:"input, textarea, a[href]", dragEnd:function(){},dragBetween:!1,placeHolderTemplate:"<li>&nbsp;</li>",scrollContainer:window,scrollSpeed:5}})(jQuery);

/*!
 * Expander - v1.4.8 - 2014-05-01
 * http://plugins.learningjquery.com/expander/
 * Copyright (c) 2015 Karl Swedberg
 * Licensed MIT (http://www.opensource.org/licenses/mit-license.php)
 */

(function(e){e.expander={version:"1.4.8",defaults:{slicePoint:100,preserveWords:!0,widow:4,expandText:"read more",expandPrefix:"&hellip; ",expandAfterSummary:!1,summaryClass:"summary",detailClass:"details",moreClass:"read-more",lessClass:"read-less",moreLinkClass:"more-link",lessLinkClass:"less-link",collapseTimer:0,expandEffect:"slideDown",expandSpeed:250,collapseEffect:"slideUp",collapseSpeed:200,userCollapse:!0,userCollapseText:"read less",userCollapsePrefix:" ",onSlice:null,beforeExpand:null,afterExpand:null,onCollapse:null,afterCollapse:null}},e.fn.expander=function(a){function s(e,a){var s="span",l=e.summary;return a?(s="div",x.test(l)&&!e.expandAfterSummary?l=l.replace(x,e.moreLabel+"$1"):l+=e.moreLabel,l='<div class="'+e.summaryClass+'">'+l+"</div>"):l+=e.moreLabel,[l," <",s+' class="'+e.detailClass+'"',">",e.details,"</"+s+">"].join("")}function l(e){var a='<span class="'+e.moreClass+'">'+e.expandPrefix;return a+='<a href="#" class="'+e.moreLinkClass+'">'+e.expandText+"</a></span>"}function n(a,s){return a.lastIndexOf("<")>a.lastIndexOf(">")&&(a=a.slice(0,a.lastIndexOf("<"))),s&&(a=a.replace(c,"")),e.trim(a)}function t(e,a){a.stop(!0,!0)[e.collapseEffect](e.collapseSpeed,function(){var s=a.prev("span."+e.moreClass).show();s.length||a.parent().children("div."+e.summaryClass).show().find("span."+e.moreClass).show(),e.afterCollapse&&e.afterCollapse.call(a)})}function r(a,s,l){a.collapseTimer&&(o=setTimeout(function(){t(a,s),e.isFunction(a.onCollapse)&&a.onCollapse.call(l,!1)},a.collapseTimer))}var i="init";"string"==typeof a&&(i=a,a={});var o,d=e.extend({},e.expander.defaults,a),p=/^<(?:area|br|col|embed|hr|img|input|link|meta|param).*>$/i,c=d.wordEnd||/(&(?:[^;]+;)?|[a-zA-Z\u00C0-\u0100]+)$/,f=/<\/?(\w+)[^>]*>/g,u=/<(\w+)[^>]*>/g,m=/<\/(\w+)>/g,x=/(<\/[^>]+>)\s*$/,h=/^(<[^>]+>)+.?/,C=/\s\s+/g,v=function(a){return e.trim(a||"").replace(C," ")},g={init:function(){this.each(function(){var a,i,c,x,C,g,S,b,y,E,k,w,L,T,I=[],P=[],j={},D=this,$=e(this),A=e([]),O=e.extend({},d,$.data("expander")||e.meta&&$.data()||{}),z=!!$.find("."+O.detailClass).length,F=!!$.find("*").filter(function(){var a=e(this).css("display");return/^block|table|list/.test(a)}).length,U=F?"div":"span",W=U+"."+O.detailClass,Q=O.moreClass+"",Z=O.lessClass+"",q=(O.moreLinkClass+"",O.lessLinkClass+"",O.expandSpeed||0),B=v($.html()),G=(v($.text()),B.slice(0,O.slicePoint));if(O.moreSelector="span."+Q.split(" ").join("."),O.lessSelector="span."+Z.split(" ").join("."),!e.data(this,"expanderInit")){for(e.data(this,"expanderInit",!0),e.data(this,"expander",O),e.each(["onSlice","beforeExpand","afterExpand","onCollapse","afterCollapse"],function(a,s){j[s]=e.isFunction(O[s])}),G=n(G),C=G.replace(f,"").length;O.slicePoint>C;)x=B.charAt(G.length),"<"===x&&(x=B.slice(G.length).match(h)[0]),G+=x,C++;for(G=n(G,O.preserveWords),g=G.match(u)||[],S=G.match(m)||[],c=[],e.each(g,function(e,a){p.test(a)||c.push(a)}),g=c,i=S.length,a=0;i>a;a++)S[a]=S[a].replace(m,"$1");if(e.each(g,function(a,s){var l=s.replace(u,"$1"),n=e.inArray(l,S);-1===n?(I.push(s),P.push("</"+l+">")):S.splice(n,1)}),P.reverse(),z)y=$.find(W).remove().html(),G=$.html(),B=G+y,b="";else{if(y=B.slice(G.length),E=e.trim(y.replace(f,"")),""===E||E.split(/\s+/).length<O.widow)return;b=P.pop()||"",G+=P.join(""),y=I.join("")+y}O.moreLabel=$.find(O.moreSelector).length?"":l(O),F&&(y=B),G+=b,O.summary=G,O.details=y,O.lastCloseTag=b,j.onSlice&&(c=O.onSlice.call(D,O),O=c&&c.details?c:O),k=s(O,F),$.html(k),L=$.find(W),T=$.find(O.moreSelector),"slideUp"===O.collapseEffect&&"slideDown"!==O.expandEffect||$.is(":hidden")?L.css({display:"none"}):L[O.collapseEffect](0),A=$.find("div."+O.summaryClass),w=function(e){e.preventDefault(),T.hide(),A.hide(),j.beforeExpand&&O.beforeExpand.call(D),L.stop(!1,!0)[O.expandEffect](q,function(){L.css({zoom:""}),j.afterExpand&&O.afterExpand.call(D),r(O,L,D)})},T.find("a").unbind("click.expander").bind("click.expander",w),O.userCollapse&&!$.find(O.lessSelector).length&&$.find(W).append('<span class="'+O.lessClass+'">'+O.userCollapsePrefix+'<a href="#" class="'+O.lessLinkClass+'">'+O.userCollapseText+"</a></span>"),$.find(O.lessSelector+" a").unbind("click.expander").bind("click.expander",function(a){a.preventDefault(),clearTimeout(o);var s=e(this).closest(W);t(O,s),j.onCollapse&&O.onCollapse.call(D,!0)})}})},destroy:function(){this.each(function(){var a,s,l=e(this);l.data("expanderInit")&&(a=e.extend({},l.data("expander")||{},d),s=l.find("."+a.detailClass).contents(),l.removeData("expanderInit"),l.removeData("expander"),l.find(a.moreSelector).remove(),l.find("."+a.summaryClass).remove(),l.find("."+a.detailClass).after(s).remove(),l.find(a.lessSelector).remove())})}};return g[i]&&g[i].call(this),this},e.fn.expander.defaults=e.expander.defaults})(jQuery);